package 
{
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import com.nemenvisual.nicecomps.*;
	
	/**
	 * ...
	 * @author Ben Foster
	 */
	public class Main extends MovieClip 
	{
		private var compManager:ComponentManager;
		private var button:Button;
		private var buttonToggle:Button;
		private var label:Text;
		private var checkbox:Checkbox;
		private var swatchdropdown:Dropdown;
		private var checkDropdown:Dropdown;
		private var dropdown:Dropdown;
		private var inputbox:InputBox;
		private var inputboxML:InputBox;
		private var dscroller:DisplayScroller;
		private var container:Sprite;
		private var cmask:Sprite;
		private var text:Text;
		private var progBar:ProgressBar;
		private var timer:Timer;
		private var perc:Number = 0;
		private var radiogroup:RadioGroup;
		private var numStepper:NumericStepper;
		private var tScroller:TextScroller;
		private var hslider:HSlider;
		private var graphButton:Button;
		private var accGraphButton:Button;
		
		private var someText:String =	"Lorem ipsum dolor sit amet, consectetur adipisicing elit," +
										" sed do eiusmod tempor incididunt ut labore et dolore magna " +
										"aliqua. Ut enim ad minim veniam, quis nostrud exercitation " +
										"exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat." +
										"Duis aute irure dolor in reprehenderit in voluptate velit esse cillum" +
										"dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat" +
										"dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat" +
										"dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat" +
										"non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.";
		
		private var colours:Array = [ 	{ colour:"Red", data:0xFF0000 },
										{ colour:"Orange", data:0xFF6700 },
										{ colour:"Yellow", data:0xF9FF00 },
										{ colour:"Green", data:0x64FF00 },
										{ colour:"Turqiose", data:0x00FF7F },
										{ colour:"Light Blue", data:0x00F3FF },
										{ colour:"Blue", data:0x0086FF },
										{ colour:"Dark Blue", data:0x0025FF },
										{ colour:"Purple", data:0x6300FF },
										{ colour:"Light Purple", data:0xC000FF },
										{ colour:"Pink", data:0xFF009E }];
		
		
		public function Main():void
		{
			var yp:Number = 70;
			
			compManager = new ComponentManager(stage);
			
			hslider = new HSlider();
			hslider.x = 10;
			hslider.y = 260;
			hslider.boxHeight = 15;
			hslider.multiplier = 100;
			hslider.addEventListener("CHANGED", onSlider);
			addChild(hslider);
			
			
			
			numStepper = new NumericStepper();
			numStepper.x = 188;
			numStepper.y = 180;
			numStepper.increment = 2;
			numStepper.maxValue = 30;
			numStepper.value = 10;
			//numStepper.boxHeight = 16;
			
			addChild(numStepper);
			
			checkbox = new Checkbox();
			checkbox.label = "Check Box";
			checkbox.boxWidth = 15;
			checkbox.x = 10;
			checkbox.y = 65;
			checkbox.textColour = 0xFFFFFF;
			checkbox.addEventListener(Event.CHANGE, onCheck);
			
			radiogroup = new RadioGroup();
			radiogroup.eventDispatcher.addEventListener(Event.CHANGE, onRadio);
			
			for (var g:int = 0; g < 4; g++)
			{
				var radio:RadioButton = new RadioButton();
				radio.label = "Radio Button " + (g+1);
				radio.boxWidth = 15;
				radio.data = "radio " + (g + 1);
				radio.x = 190;
				radio.y = yp;
				radio.textColour = 0xFFFFFF;
				radiogroup.addRadio(radio);
				yp += 20;
				addChild(radio);
			}
			
			container = new Sprite();
			container.x = 340;
			container.y = 30;
			
			cmask = new Sprite();
			cmask.x = 340;
			cmask.y = 30;
			cmask.graphics.beginFill(0xFF0000, 1);
			cmask.graphics.drawRect(0, 0, 200, 200);
			cmask.graphics.endFill();
			
			yp = 0;
			
			for (var m:int = 0; m < 7; m++)
			{
				var s:Shape = new Shape();
				s.graphics.beginFill(0xFFFFFF, 1);
				s.graphics.drawRect(0, 0, 200, 80);
				s.graphics.endFill();
				s.y = yp;
				container.addChild(s);
				
				yp += 85;
			}
			
			dscroller = new DisplayScroller();
			dscroller.x = 541;
			dscroller.y = 30;
			dscroller.baseColour = 0x000000;
			dscroller.boxHeight = 200;
			dscroller.setTarget(container, 200);
			
			addChild(container);
			addChild(cmask);
			
			container.mask = cmask;
			
			dscroller.update();
			
			swatchdropdown = new Dropdown();
			swatchdropdown.type = ListItemType.SWATCH;
			swatchdropdown.prompt = "Swatch Selector";
			swatchdropdown.x = 10;
			swatchdropdown.y = 160;
			swatchdropdown.boxHeight = 20;
			swatchdropdown.boxWidth = 120;
			swatchdropdown.maxToDisplay = 11;
			
			for (var i:int = 0; i < colours.length; i++)
			{
				swatchdropdown.addItem( { label:colours[i].colour, data:colours[i].data, colour:colours[i].data } );
			}
			//trace(swatchdropdown.numItems);
			
			swatchdropdown.addEventListener("dropdownSelect", onSelectColour);
			
			dropdown = new Dropdown();
			dropdown.prompt = "Dropdown";
			dropdown.x = 10;
			dropdown.y = 110;
			dropdown.maxToDisplay = 5;
			dropdown.boxHeight = 20;
			
			for (var j:int = 0; j < 10; j++)
			{
				dropdown.addItem( { label:"Item " + (j+1), data:j } );
			}
			
			checkDropdown = new Dropdown();
			checkDropdown.type = ListItemType.CHECK;
			checkDropdown.prompt = "Choose options";
			checkDropdown.x = 10;
			checkDropdown.y = 210;
			checkDropdown.maxToDisplay = 8;
			checkDropdown.boxHeight = 20;
			checkDropdown.boxWidth = 120;
			checkDropdown.textColour = 0x000000;
			
			for (var k:int = 0; k < colours.length; k++)
			{
				checkDropdown.addItem( { label:"Item " + (k+1), data:"Item "+(k+1) } );
			}
			checkDropdown.addEventListener("itemsSelected", onItemsSelected);
			
			inputbox = new InputBox();
			inputbox.promt = "enter text here";
			inputbox.x = 10;
			inputbox.y = 305;
			inputbox.addEventListener("submt", onSubmit);
			
			inputboxML = new InputBox();
			inputboxML.promt = "enter text here";
			inputboxML.multiline = true;
			//inputboxML.maxLines = 4;
			inputboxML.x = 10;
			inputboxML.y = 355;
			inputboxML.addEventListener("textExpand", onTextExpand);
			
			label = new Text();
			label.textColour = 0xAAAAAA;
			label.size = 15;
			label.bold = true;
			label.italic = true;
			label.boxWidth = 150;
			label.boxHeight = 22;
			label.selectable = false;
			label.text = "Button and Toggle Button";
			label.y = inputboxML.y + inputboxML.boxHeight+5;
			label.x = 10;
			
			button = new Button();
			button.x = 10;
			button.y = inputboxML.y + inputboxML.boxHeight + 10 + label.height;
			button.label = "Button";
			button.toggle = false;
			
			buttonToggle = new Button();
			buttonToggle.x = 120;
			buttonToggle.y = inputboxML.y + inputboxML.boxHeight + 10 + label.height;
			buttonToggle.label = "Toggle Button";
			buttonToggle.toggle = true;
			
			
			
			addChild(label);
			
			text = new Text();
			text.x = 340;
			text.y = 262;
			text.boxWidth = 220;
			text.boxHeight = 20;
			text.size = 12;
			text.selectable = true;
			text.useAccent = true;
			text.text = "This some text in the Text component";
			
			addChild(text);
			
			progBar = new ProgressBar();
			progBar.x = 340;
			progBar.y = 305;
			progBar.boxWidth = 200;
			progBar.setProgress(0, 100);
			addChild(progBar);
			
			timer = new Timer(100);
			timer.addEventListener(TimerEvent.TIMER, onTimer);
			timer.start();
			
			tScroller = new TextScroller();
			tScroller.x = 629;
			tScroller.y = 341;
			tScroller.baseColour = 0x000000;
			tScroller.boxHeight = 155;
			textBox.text = someText;
			tScroller.targetText = textBox;
			tScroller.update();
			
			graphButton = new Button();
			graphButton.x = 33;
			graphButton.y = 535;
			graphButton.label = null;
			graphButton.graphic = new GraphicA();
			
			addChild(graphButton);
			
			accGraphButton = new Button();
			accGraphButton.x = 200;
			accGraphButton.y = 535;
			accGraphButton.label = null;
			accGraphButton.graphic = new GraphicB();
			accGraphButton.allowTint = true;
			
			addChild(accGraphButton);
			
			addChild(tScroller);
			addChild(dscroller);
			addChild(button);
			addChild(buttonToggle);
			addChild(checkbox);
			addChild(inputbox);
			addChild(inputboxML);
			addChild(checkDropdown);
			addChild(swatchdropdown);
			addChild(dropdown);
			
			compManager.accent = 0x0088FF;
		}
		
		private function onSlider(e:Event):void
		{
			traceTxt.text = "slider value: " + Math.round(e.target.value);
		}
		
		private function onSubmit(e:Event):void
		{
			traceTxt.text = "Text Submitted";
		}
		
		private function onRadio(e:Event):void
		{
			traceTxt.text = radiogroup.selectedItem.data;
		}
		
		private function onTimer(e:TimerEvent):void
		{
			perc = perc == 100 ? 0 : perc += 1;
			progBar.setProgress(perc, 100);
		}
		
		private function onTextExpand(e:Event):void
		{
			label.y = inputboxML.y + inputboxML.boxHeight + 10;
			button.y = inputboxML.y + inputboxML.boxHeight + 10 + label.height
			buttonToggle.y = inputboxML.y + inputboxML.boxHeight + 10 + label.height
		}
		
		private function onSelectColour(e:Event):void
		{
			compManager.accent = e.target.selectedItem.data;
		}
		
		private function onItemsSelected(e:Event):void
		{
			traceTxt.text = "Items Selected: ";
			for (var i:int = 0; i < e.target.selectedItems.length; i++)
			{
				traceTxt.appendText( e.target.selectedItems[i].data);
				if (i < e.target.selectedItems.length - 1)
				{
					traceTxt.appendText(",");
				}
			}
		}
		
		private function onCheck(e:Event):void
		{
			traceTxt.text = "Selected: " +e.target.selected;
		}
		
		
	}
	
}